/**
 *  并发队列
 * @param {function():Promise.<any>} job 
 * @param {Number} queueNum  并发数量
 *  @param {Number}  maxTime 执行次数
 */
async function SimpleQueue(job, maxTime, queueNum) {
  var tskList = []; //
  var result=new Array(maxTime);
  async function runAction(tskid, job,index) {
    result[index]=await job();
    return tskid;
  }
  for (let i = 0; i < maxTime; i++) {
    if (i < queueNum) {
      tskList[i] = runAction(i, job,i);
      continue;
    }
    var index = await Promise.race(tskList);
    tskList[index] = runAction(index, job,i);
  }
  await Promise.all(tskList);
  return result;
}
exports.SimpleQueue=SimpleQueue;

