if (typeof Promise === "undefined") {
  Promise = require("es6-promise").Promise;
}
/**
 * 返回闭包函数
 * @param {number} listSize 队列长度
 * @param {boolean} mustDone 需要等待完成追加
 *
 */
module.exports = function(listSize, mustDone) {
  var actionList = [Promise.resolve()];
  actionList[0].done = true;
  /**
   *
   * @template T,R
   * @param {function(T):R} func 加锁的函数
   * @param {T} argu 回调参数, 函数的参数
   * @param {number} timedOut  最长时间
   * @returns {Promise.<R>} 原返回函数 promise参数
   */
  function run(func, argu, timedOut) {
    //    // 先返回 同步代码
    function final() {
      //  入口函数
      if (listSize && actionList.length > listSize) actionList.shift();
      var p = func.apply(this, argu);
      var laster1 = actionList[actionList.length - 1];
      //标记执行者??
      if (p instanceof Promise) {
        return new Promise(function(res, err) {
          var t =timedOut &&
            setTimeout(function() {
              laster1.done = true;
              console.log("$$$ timeout");
              err({
                timedOut: timedOut
              });
            }, timedOut);
          //超时

          p.then(
            function(d) {
              t && clearTimeout(t);
              laster1.done = true;
              res(d);
            },
            function(e) {
              laster1.done = true;
              t && clearTimeout(t);
              err(e);
            }
          );
        });
      } else {
        return Promise.resolve(p);
      }
    }
    var later = actionList[actionList.length - 1];
    if (!mustDone || later.done) {
      var next = later.then(final, final);
      //选择向后面执行
      actionList.push(next);
      return next;
    } else {
      return Promise.resolve("no done");
    }
  }
  return run;
};
